# Contributing

How can you contribute to this project ?

## Add issue

You can help by finding new issues & reporting them by creating [new issues](https://gitlab.com/kapt/open-source/django-brouillons/-/issues).

## Add code

You can help by picking an issue, or choosing to add a new test/feature (create an issue before you start coding).

0. Create a new issue, receive positive feedback.

1. Fork the repo, clone it.

2. Install pre-commit & unit tests dependencies.
    ```bash
    poetry install
    ```

3. Install pre-commit hooks.
    ```bash
    pre-commit install
    ```

4. Create new branch.
    ```bash
    git checkout -b my_feature_branch
    ```

5. Add your code.

6. Add tests and ensure that tests are running OK
    ```bash
    ./launch_tests.sh
    ```

7. Add yourself in [AUTHORS.md](AUTHORS.md).

8. Commit, push.
    *Make sure that pre-commit runs isort, black, flake8, django-upgrade, pyupgrade, refurb.*

9. Create a [Merge Request](https://docs.gitlab.com/ee/user/project/merge_requests/creating_merge_requests.html).
----

### Commit description guidelines

We're using bluejava's [git-commit-guide](https://github.com/bluejava/git-commit-guide) for our commits description. Here's a quick reference:

![Reference git-commit-guide](https://raw.githubusercontent.com/bluejava/git-commit-guide/master/gitCommitMsgGuideQuickReference.png)
